import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import useMutation from './use-mutation';
import { reactComponentPropType } from './propTypesValidators';

var Mutation = function Mutation(_ref) {
  var requestSelector = _ref.requestSelector,
      type = _ref.type,
      requestKey = _ref.requestKey,
      children = _ref.children,
      Component = _ref.component,
      extraProps = _objectWithoutPropertiesLoose(_ref, ["requestSelector", "type", "requestKey", "children", "component"]);

  var mutation = useMutation({
    requestSelector: requestSelector,
    type: type,
    requestKey: requestKey
  });

  if (children) {
    return children(mutation);
  }

  return React.createElement(Component, _extends({
    mutation: mutation
  }, extraProps));
};

Mutation.propTypes = process.env.NODE_ENV !== "production" ? {
  requestSelector: PropTypes.func,
  type: PropTypes.oneOfType([PropTypes.string, PropTypes.func]).isRequired,
  requestKey: PropTypes.string,
  children: PropTypes.func,
  component: reactComponentPropType('Mutation')
} : {};
export default Mutation;