import { useMemo } from 'react';
import { useSelector } from 'react-redux';
import { getMutation } from 'redux-saga-requests';

var useMutation = function useMutation(_ref) {
  var requestSelector = _ref.requestSelector,
      type = _ref.type,
      requestKey = _ref.requestKey;
  var mutationSelector = useMemo(function () {
    return getMutation({
      requestSelector: requestSelector,
      type: type,
      requestKey: requestKey
    });
  }, [(requestSelector, type, requestKey)]);
  return useSelector(mutationSelector);
};

export default useMutation;