"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useMutation = _interopRequireDefault(require("./use-mutation"));

var _propTypesValidators = require("./propTypesValidators");

var Mutation = function Mutation(_ref) {
  var requestSelector = _ref.requestSelector,
      type = _ref.type,
      requestKey = _ref.requestKey,
      children = _ref.children,
      Component = _ref.component,
      extraProps = (0, _objectWithoutPropertiesLoose2["default"])(_ref, ["requestSelector", "type", "requestKey", "children", "component"]);
  var mutation = (0, _useMutation["default"])({
    requestSelector: requestSelector,
    type: type,
    requestKey: requestKey
  });

  if (children) {
    return children(mutation);
  }

  return _react["default"].createElement(Component, (0, _extends2["default"])({
    mutation: mutation
  }, extraProps));
};

Mutation.propTypes = process.env.NODE_ENV !== "production" ? {
  requestSelector: _propTypes["default"].func,
  type: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func]).isRequired,
  requestKey: _propTypes["default"].string,
  children: _propTypes["default"].func,
  component: (0, _propTypesValidators.reactComponentPropType)('Mutation')
} : {};
var _default = Mutation;
exports["default"] = _default;