"use strict";

exports.__esModule = true;
exports.reactComponentPropType = void 0;

var _reactIs = require("react-is");

var reactComponentPropType = function reactComponentPropType(componentName) {
  return function (props, propName) {
    if (props[propName] && !(0, _reactIs.isValidElementType)(props[propName])) {
      return new Error("Invalid prop '" + propName + "' supplied to '" + componentName + "': the prop is not a valid React component");
    }

    return null;
  };
};

exports.reactComponentPropType = reactComponentPropType;